package de.ivu.elect.presentation.gebietsbaum.action;

import de.ivu.elect.business.gebietsbaum.entity.Gebietsarteigenschaft;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.wahl.boundary.WahlkonfigurationAnpassbar;
import de.ivu.elect.presentation.gebietsbaum.GebietsarteigenschaftEditView;

import javax.annotation.Nonnull;
import javax.inject.Inject;
import javax.inject.Named;

/**
 *  on 29.06.2015.
 */
@Named(GebietsarteigenschaftEditAction.COMPONENT_NAME)
public class GebietsarteigenschaftEditAction extends AbstractGebietsartsarteigenschaftAction {

  public static final String COMPONENT_NAME = "gebietsarteigenschaftEditAction";

  @Inject
  private transient WahlkonfigurationAnpassbar wahlkonfigurationAnpassbar;

  @Override
  protected UseCasePermission getRequiredPermission() {
    return UseCasePermission.GEBIETSARTEIGENSCHAFT_EDIT;
  }

  @Override
  protected boolean isDisabledInternal(@Nonnull Gebietsarteigenschaft gebietsarteigenschaft) {
    return super.isDisabledInternal(gebietsarteigenschaft) || !wahlkonfigurationAnpassbar.isWahlkonfigurationAnpassbar(gebietsarteigenschaft.getWahlart().getMandant());
  }

  @Override
  protected String doIt(Gebietsarteigenschaft gebietsarteigenschaft) {
    conversationSelect.setEntity(gebietsarteigenschaft);
    return GebietsarteigenschaftEditView.VIEW_ID;
  }

  @Override
  public String getLabelKey() {
    return "entity.edit.action.edit";
  }

  @Override
  public String getIcon() {
    return appIcons.getIconEdit();
  }
}
